/* delcx/Makefile.cpp --- C pre-processor Makefile for detri. */

/* USAGE: cpp -P ${CPPMK} > ${TMPMK}; make -k TMPMK=${TMPMK} -f ${TMPMK} ... */

/* Targets.  (CHANGE THIS ACCORDING TO YOUR NEEDS!) */
DEST=    ../bin
LIB=     ../lib
INCLUDE= ../include -I../detri

/* Paramters: DEPEND, SHELL, CC, CPP, CPPMK, TMPMK, COPT. */
/* System specifics: CCFLAGS, AR, RANLIB, MALLOC. */
#include "Makefile.sys"

/* Other libraries. */
INCLS= -I${INCLUDE}
LIBRARIES= -l_sos${DBX} -l_lia${DBX} -l_basic${DBX} 
LIBS= -L${LIB}

/* Source and object files. */
MODULES= delcx.c ../detri/dt.c regular.c flip.c search.c \
         tridag.c infinite.c lambda2.c lambda3.c misc.c \
         cascade.c ../detri/trist.c ../detri/peel.c \
         ../detri/print_dt.c primflip.c
H_FILES= delcx.h ../detri/dt.h ../detri/trist.h
OBJECTS= ${MODULES:.c=.o}
MATHOBJECTS= math-points.o

/* Interface. */
normal: ;       ${MAKE} -k -f ${TMPMK} delcx REG="-DREGULAR"
debug:  ;       ${MAKE} -k -f ${TMPMK} delcx COPT="-D__DEBUG__" REG="-DREGULAR" DBX=-g
vrdebug: ;      ${MAKE} -k -f ${TMPMK} delcx VDBG="-DVDEBUG" REG="-DREGULAR" DBX=-g
vsrdebug: ;     ${MAKE} -k -f ${TMPMK} delcx COPT="-D__DEBUG__" VDBG="-DVDEBUG -DSDEBUG" REG="-DREGULAR" DBX=-g
del:    ;       ${MAKE} -k -f ${TMPMK} rdetri
remove: ;       rm -f ${OBJECTS}
all:    normal;

/* BEGIN Meta Interface: make detri_new */
/* Note: This is here so that we can package Detri stand-alone,
   without the alpha shape software and it's top-level Makefile. */

BASIC= ../basic
LIA=   ../lia
SOS=   ../sos
DETRI= ./

HD=echo "\n\n*** X ***\n"
MK= ${MAKE} -k CC="${CC}" CPP="${CPP}" COPT="${COPT}"

delcx_new:;   ${MK} check soslibs_           delcx_
delcx_debug:; ${MK} check soslibs_d          delcx_d
delcx_all:;   ${MK} check soslibs_d soslibs_ delcx_
soslibs_: basic_ lia_ sos_
delcx_:;  @/bin/csh -cf '${HD:X=Delcx}; cd ${DELCX}; ${MK} new'
basic_:;  @/bin/csh -cf '${HD:X=Basic}; cd ${BASIC}; ${MK} new'
lia_:;    @/bin/csh -cf '${HD:X=Lia};   cd ${LIA};   ${MK} new'
sos_:;    @/bin/csh -cf '${HD:X=SoS};   cd ${SOS};   ${MK} new'
basic_d:; @/bin/csh -cf '${HD:X=Basic}; cd ${BASIC}; ${MK} clear debug'
lia_d:;   @/bin/csh -cf '${HD:X=Lia};   cd ${LIA};   ${MK} clear debug'
sos_d:;   @/bin/csh -cf '${HD:X=SoS};   cd ${SOS};   ${MK} clear debug'
check:;   @/bin/csh -cf '           \
  echo Checking for target dirs;     \
  if (! -e ${DEST})    mkdir ${DEST}; \
  if (! -e ${LIB})     mkdir ${LIB};   \
  if (! -e ${INCLUDE}) mkdir ${INCLUDE} \
'

/* Internal rules. */
rdetri: ${OBJECTS}; ${CC} ${CCFLAGS} ${DBX} ${COPT} ${OBJECTS} \
                         -o ${DEST}/rdetri ${LIBS} ${LIBRARIES} ${MALLOC} -lm;
delcx: ${OBJECTS}; ${CC} ${CCFLAGS} ${DBX} ${COPT} ${OBJECTS} \
                        -o ${DEST}/delcx ${LIBS} ${LIBRARIES} ${MALLOC} -lm;
/* Special rule for infinite.c - should be used without optimization */
infinite.o: infinite.c ${H_FILES}; ${CC} ${CCFLAGS} ${DBX} ${REG} ${VDBG} ${INCLS} -c $*.c -o $*.o 
/* Generic rule to compile source files. */
.c.o: ${H_FILES}; ${CC} ${CCFLAGS} ${DBX} ${COPT} ${REG} ${VDBG} ${INCLS} -c $*.c -o $*.o

/* To compute dependencies with "make depend" ... */
depend:; ${DEPEND} -f${TMPMK} -- ${INCLS} ${MODULES}
