/* delcx/crash.c ---
   Stuff that might be usefull if big CRASH happened: ie, regular/
   flip got stuck.  Each routine is globally accessible and starts with three
   underscores.  It also includes old, now (hopefully!) obsolete tests.
   ALL THIS IS PRETTY MUCH USELESS NOW!
   --Ernst. */

/*--------------------------------------------------------------------------*/

#include "delcx.h"
#include "dt.h"

/*--------------------------------------------------------------------------*/

/* this better be the same as in flip.c */
#define _WHITE  ' '  /* regular */
#define _GREEN  'g'  /* non-regular */
#define _RED    'r'  /* non-transformable */

static FILE *ntf;

/*--------------------------------------------------------------------------*/

___crash (the_ntf, reds)
     FILE *the_ntf;
     /*i*/ int reds;
     /* Save non-transfromables in FILE ntf.  Let's hope it's never called. */
{
  int t, i, e, face, red, degree;
  char c;
  ntf = the_ntf;
  print ("___crash: Producing non_trans_file ...\n");
  fprint (ntf, "***\n%d non-transformable (red) triangles\n", reds);
  trist_for (t)
    if (is_current_triangle (t))
      if (trist_color (t) == _RED)
	{
	  trist_print (ntf, t);
	  e = EdFacet (t, 0);
	  upfor (i, 1, 3)
	    {
	      fprint (ntf, " edge: %4d to %4d  ", Org (e), Dest (e));
	      degree = red = 0;
	      face = e;
	      loop
		{
		  c = trist_color (TrIndex (face));
		  if (c == _RED)
		    red ++;
		  degree ++;
		  face = Fnext (face);
		  if (face == e) break;
		}
	      fprint (ntf, "%3dd %3dr :", degree, red);
	      face = e;
	      loop
		{
		  fprint (ntf, "%d^%d%c:",
			  TrIndex (face), Dest (Enext (face)),
			  trist_color (TrIndex (face)));
		  face = Fnext (face);
		  if (face == e)
		    break;
		}
	      fprint (ntf, " ");
	      if (degree == 4)
		___degree_4 (e);
	      else if (degree == 3)
		___degree_3 (e);
	      fprint (ntf, "\n");
	      e = Enext (e);
	    }
	}
}

/*--------------------------------------------------------------------------*/

___degree_4 (e)
     /*i*/ int e;
{
  int a, b, c, d, o = Dest (e), p = Org (e);
  int i;
  a = Dest (Enext (e));  e = Fnext (e);
  b = Dest (Enext (e));  e = Fnext (e);
  c = Dest (Enext (e));  e = Fnext (e);
  d = Dest (Enext (e));  e = Fnext (e);
  fprint (ntf, "c5=%d ", ___c5 (a, b, c, d, o, p));
  {
    fprint (ntf, "nDs: ");
    i = 0;
    if (sos_in_sphere_inf (d, p, o, a, b)) i ++;
    if (sos_in_sphere_inf (a, p, o, b, c)) i ++;
    if (sos_in_sphere_inf (d, p, o, c, b)) i ++;
    if (sos_in_sphere_inf (a, p, o, d, c)) i ++;
    fprint (ntf, "%d versus ", i);
    i = 0;
    if (sos_in_sphere_inf (b, a, c, o, d)) i ++;
    if (sos_in_sphere_inf (o, a, c, b, p)) i ++;
    if (sos_in_sphere_inf (b, a, c, p, d)) i ++;
    if (sos_in_sphere_inf (o, a, c, d, p)) i ++;
    fprint (ntf, "%d and ", i);
    i = 0;
    if (sos_in_sphere_inf (a, d, b, o, c)) i ++;
    if (sos_in_sphere_inf (o, d, b, a, p)) i ++;
    if (sos_in_sphere_inf (a, d, b, p, c)) i ++;
    if (sos_in_sphere_inf (o, d, b, c, p)) i ++;
    fprint (ntf, "%d", i);
  }
}

/*--------------------------------------------------------------------------*/

___degree_3 (e)
     /*i*/ int e;
{
  int a, b, c, o = Dest (e), p = Org (e);
  a = Dest (Enext (e));  e = Fnext (e);
  b = Dest (Enext (e));  e = Fnext (e);
  c = Dest (Enext (e));  e = Fnext (e);
  fprint (ntf, "c4x=%d", ___c4x (a, b, c, o, p));
}

/*--------------------------------------------------------------------------*/

___c5 (a, b, c, d, e, f)
     /*i*/ int a, b, c, d, e, f;
     /* stupid way to test convexity of 5 points */
{
  return (___ch (a, b, f,  c, d, e) and
          ___ch (f, b, c,  a, d, e) and
          ___ch (c, d, f,  a, b, e) and
          ___ch (a, d, f,  b, c, e) and
          ___ch (a, b, e,  c, d, f) and
          ___ch (b, c, e,  d, a, f) and
          ___ch (c, d, e,  a, b, f) and
          ___ch (d, a, e,  b, c, f));
}

/*--------------------------------------------------------------------------*/

___ch (a, b, f, c, d, e)
     /*i*/ int a, b, f, c, d, e;
     /* ? */
{
  int
    one  = sos_positive3_inf (c, a, b, f),
    two  = sos_positive3_inf (d, a, b, f),
    three = sos_positive3_inf (e, a, b, f);
  return ((one == two) and (two == three));
}

/*--------------------------------------------------------------------------*/

___c4x (x, y, z, o, p)  /* ConvexDouble */
     /*i*/ int x, y, z, o, p;
     /* ? */
{
  int po;
  return (((po = sos_positive3_inf (o, x, y, z)) !=
	   sos_positive3_inf (p, x, y, z)) and
          (po == sos_positive3_inf (o, p, x, y)) and
          (po == sos_positive3_inf (o, p, y, z)) and
          (po == sos_positive3_inf (o, p, z, x)));
}

/*--------------------------------------------------------------------------*/

___test_colors (remark)
     /*i*/ char remark[];
{
  int wrong = FALSE;
  int t;
  int i, j, k, u, v, e;
  print ("test_colors: %s ...\n", remark);
  trist_for (t)
    if (is_current_triangle (t))
      if (not ___color_okay (EdFacet (t, 0)))
	{
	  e = EdFacet (t, 0);
	  trist_triangle (e, &i, &j, &k);
	  v = Dest (Enext (Fnext (e)));
	  u = Dest (Enext (Fnext (Sym (e))));             
	  print ("oh color t%d '%c' (%d,%d,%d) %d %d   ch = %d %d\n",
		 t, trist_color (t), i,j,k,u,v,
		 __is_CH (e), __is_CH (Sym (e)));
	  wrong = TRUE;
	}
  Assert_always (not wrong);
}

/*--------------------------------------------------------------------------*/

___color_okay (e)
     /*i*/ int e;
{
  char c = trist_color (TrIndex (e));
  if (not is_regular (e))
    return ((c == _GREEN) or (c == _RED));
  else
    return (not ((c == _GREEN) or (c == _RED)));
}

/*--------------------------------------------------------------------------*/

__is_CH (h)
     /*i*/ int h;
     /* Checks locally (!) whether h is on CH of cell complex built so far.
        It uses geometric primitives for its decision. 
        NOTE: Checks the edfacet rather than the triangle! <<<<<
        NOTE: I think we could also do this by checking existence of incident
        tetrahedra !!!????
        NOTE: identical to hull_triangle() in delaunay.c!! */
{
  int x, y, z, u, v, w;
  trist_triangle (h, &x, &y, &z);
  u = Dest (Enext (Fnext (h)));
  v = Dest (Enext (Fnext (h = Enext (h))));
  w = Dest (Enext (Fnext (Enext (h))));
  if (sos_positive3_inf (u, x, y, z) or
      sos_positive3_inf (v, x, y, z) or
      sos_positive3_inf (w, x, y, z))
    return (FALSE);
  else
    return (TRUE);
}
