/* delcx/infinite.h -- Definitions used to handle infinite points.
   			These come from infinite.c and col.c.		*/

#ifndef __INFINITE_H__  /* Include only once! */
#define __INFINITE_H__  1

/*--------------------------------------------------------------------------*/

extern int num_vert;

#define is_infinite(x)	      ((x > num_vert) ? 1 : 0)

/* Note: above needs to return either 1 or 0 -- nothing else! */

extern short int const4_1inf[4][2], const4_2inf[3][3][2], const4_3inf[4];
extern short int const5_2inf[3][3][2], const5_3inf[4][2];

#define sign4_3inf(u, v, w)   (const4_3inf[missing_inf_index(u, v, w)])

#define coef4_2inf(u, v)      (const4_2inf[u-1][v-2][0])
#define col4_2inf(u, v)       (const4_2inf[u-1][v-2][1])

#define coef4_1inf(u)         (const4_1inf[u-1][0])
#define col4_1inf(u)          (const4_1inf[u-1][1])

#define coef5_3inf(u, v, w)   (const5_3inf[missing_inf_index(u, v, w)][0])
#define col5_3inf(u, v, w)    (const5_3inf[missing_inf_index(u, v, w)][1])

#define coef5_2inf(u, v)      (const5_2inf[u-1][v-2][0])
#define col5_2inf(u, v)       (const5_2inf[u-1][v-2][1])


void open_infinite(int n);
int num_infinite4(int w, int x, int y, int z);
int num_infinite5(int v, int w, int x, int y, int z);
SoS_primitive_result * sos_lambda4_inf(int i, int j, int k, int l);
SoS_primitive_result * sos_lambda5_inf(int i, int j, int k, int l, int m);
int sos_in_sphere_inf(int o, int i, int j, int k, int p);
int sos_in_sphere_inf_p(int o, int i, int j, int k, int p);
int sos_positive3_inf(int h, int i, int j, int k);
void infinite_summary(FILE *file);


/*------------------------------------------------------------------------*/
/*                       lambda2.c  and  lambda3.c                        */

SoS_primitive_result * sos_lambda2_col(int i, int j, int c);
SoS_primitive_result * sos_lambda3_col(int i, int j, int k, int c1, int c2);

#endif  /* #ifndef __INFINITE_H__ */
